NDB_BLOB_TOOL(1)

NAME
ndb_blob_tool - check and repair BLOB and TEXT columns of NDB Cluster tables

SYNOPSIS

ndb_blob_tool options table [column, ...]

DESCRIPTION

This tool can be used to check for and remove orphaned BLOB column parts from NDB tables, as well as to generate a file listing any orphaned parts. It is sometimes useful in diagnosing and repairing corrupted or damaged NDB tables containing BLOB or TEXT columns.

The basic syntax for ndb_blob_tool is shown here:

    ndb_blob_tool [options] table [column, ...]

Unless you use the --help option, you must specify an action to be performed by including one or more of the options --check-orphans, --delete-orphans, or --dump-file. These options cause ndb_blob_tool to check for orphaned BLOB parts, remove any orphaned BLOB parts, and generate a dump file listing orphaned BLOB parts, respectively, and are described in more detail later in this section.

You must also specify the name of a table when invoking ndb_blob_tool. In addition, you can optionally follow the table name with the (comma-separated) names of one or more BLOB or TEXT columns from that table. If no columns are listed, the tool works on all of the table's BLOB and TEXT columns. If you need to specify a database, use the --database (-d) option.

The --verbose option provides additional information in the output about the tool's progress.

Options that can be used with ndb_blob_tool are shown in the following table. Additional descriptions follow the table.

Table 21.26. Command-line options used with the program ndb_blob_tool
Format | Description | Added, Deprecated, or Removed
--add-missing | Write dummy blob parts to take place of those which are missing | ADDED: NDB 7.5.18, NDB 7.6.14
--character-sets-dir=path | Directory containing character sets | (Supported in all NDB releases based on MySQL 5.7)
--check-missing | Check for blobs having inline parts but missing one or more parts from parts table | ADDED: NDB 7.5.18, NDB 7.6.14
--check-orphans | Check for blob parts having no corresponding inline parts | (Supported in all NDB releases based on MySQL 5.7)
--connect-retries=# | Number of times to retry connection before giving up | (Supported in all NDB releases based on MySQL 5.7)
--connect-retry-delay=# | Number of seconds to wait between attempts to contact management server | (Supported in all NDB releases based on MySQL 5.7)
--connect-string=connection_string, -c connection_string | Same as --ndb-connectstring | (Supported in all NDB releases based on MySQL 5.7)
--core-file | Write core file on error; used in debugging | (Supported in all NDB releases based on MySQL 5.7)
--database=name, -d name | Database to find the table in | (Supported in all NDB releases based on MySQL 5.7)
--defaults-extra-file=path | Read given file after global files are read | (Supported in all NDB releases based on MySQL 5.7)
--defaults-file=path | Read default options from given file only | (Supported in all NDB releases based on MySQL 5.7)
--defaults-group-suffix=string | Also read groups with concat(group, suffix) | (Supported in all NDB releases based on MySQL 5.7)
--delete-orphans | Delete blob parts having no corresponding inline parts | (Supported in all NDB releases based on MySQL 5.7)
--dump-file=file | Write orphan keys to specified file | (Supported in all NDB releases based on MySQL 5.7)
--help, -? | Display help text and exit | (Supported in all NDB releases based on MySQL 5.7)
--login-path=path | Read given path from login file | (Supported in all NDB releases based on MySQL 5.7)
--ndb-connectstring=connection_string, -c connection_string | Set connect string for connecting to ndb_mgmd. Syntax: "[nodeid=id;][host=]hostname[:port]". Overrides entries in NDB_CONNECTSTRING and my.cnf | (Supported in all NDB releases based on MySQL 5.7)
--ndb-mgmd-host=connection_string, -c connection_string | Same as --ndb-connectstring | (Supported in all NDB releases based on MySQL 5.7)
--ndb-nodeid=# | Set node ID for this node, overriding any ID set by --ndb-connectstring | (Supported in all NDB releases based on MySQL 5.7)
--ndb-optimized-node-selection | Enable optimizations for selection of nodes for transactions. Enabled by default; use --skip-ndb-optimized-node-selection to disable | (Supported in all NDB releases based on MySQL 5.7)
--no-defaults | Do not read default options from any option file other than login file | (Supported in all NDB releases based on MySQL 5.7)
--print-defaults | Print program argument list and exit | (Supported in all NDB releases based on MySQL 5.7)
--usage, -? | Display help text and exit; same as --help | (Supported in all NDB releases based on MySQL 5.7)
--verbose, -v | Verbose output | (Supported in all NDB releases based on MySQL 5.7)
--version, -V | Display version information and exit | (Supported in all NDB releases based on MySQL 5.7)

    • --add-missing
    Command-Line Format | --add-missing
    Introduced | 5.7.29-ndb-7.6.14

    For each inline part in NDB Cluster tables which has no corresponding BLOB part, write a dummy BLOB part of the required length, consisting of spaces.

    • --character-sets-dir
    Command-Line Format | --character-sets-dir=path

    Directory containing character sets.

    • --check-missing
    Command-Line Format | --check-missing
    Introduced | 5.7.29-ndb-7.6.14

    Check for inline parts in NDB Cluster tables which have no corresponding BLOB parts.

    • --check-orphans
    Command-Line Format | --check-orphans

    Check for BLOB parts in NDB Cluster tables which have no corresponding inline parts.

    • --connect-retries
    Command-Line Format | --connect-retries=#
    Type | Integer
    Default Value | 12
    Minimum Value | 0
    Maximum Value | 12

    Number of times to retry connection before giving up.

    • --connect-retry-delay
    Command-Line Format | --connect-retry-delay=#
    Type | Integer
    Default Value | 5
    Minimum Value | 0
    Maximum Value | 5

    Number of seconds to wait between attempts to contact management server.

    • --connect-string
    Command-Line Format | --connect-string=connection_string
    Type | String
    Default Value | [none]

    Same as --ndb-connectstring.

    • --core-file
    Command-Line Format | --core-file

    Write core file on error; used in debugging.

    • --database=db_name, -d
    Command-Line Format | --database=name
    Type | String
    Default Value | [none]

    Specify the database to find the table in.

    • --defaults-extra-file
    Command-Line Format | --defaults-extra-file=path
    Type | String
    Default Value | [none]

    Read given file after global files are read.

    • --defaults-file
    Command-Line Format | --defaults-file=path
    Type | String
    Default Value | [none]

    Read default options from given file only.

    • --defaults-group-suffix
    Command-Line Format | --defaults-group-suffix=string
    Type | String
    Default Value | [none]

    Also read groups with concat(group, suffix).

    • --delete-orphans
    Command-Line Format | --delete-orphans

    Remove BLOB parts from NDB Cluster tables which have no corresponding inline parts.

    • --dump-file=file
    Command-Line Format | --dump-file=file
    Type | File name
    Default Value | [none]

    Writes a list of orphaned BLOB column parts to file. The information written to the file includes the table key and BLOB part number for each orphaned BLOB part.

    • --help
    Command-Line Format | --help

    Display help text and exit.

    • --login-path
    Command-Line Format | --login-path=path
    Type | String
    Default Value | [none]

    Read given path from login file.

    • --ndb-connectstring
    Command-Line Format | --ndb-connectstring=connection_string
    Type | String
    Default Value | [none]

    Set connect string for connecting to ndb_mgmd. Syntax: "[nodeid=id;][host=]hostname[:port]". Overrides entries in NDB_CONNECTSTRING and my.cnf.

    • --ndb-mgmd-host
    Command-Line Format | --ndb-mgmd-host=connection_string
    Type | String
    Default Value | [none]

    Same as --ndb-connectstring.

    • --ndb-nodeid
    Command-Line Format | --ndb-nodeid=#
    Type | Integer
    Default Value | [none]

    Set node ID for this node, overriding any ID set by --ndb-connectstring.

    • --ndb-optimized-node-selection
    Command-Line Format | --ndb-optimized-node-selection

    Enable optimizations for selection of nodes for transactions. Enabled by default; use --skip-ndb-optimized-node-selection to disable.

    • --no-defaults
    Command-Line Format | --no-defaults

    Do not read default options from any option file other than login file.

    • --print-defaults
    Command-Line Format | --print-defaults

    Print program argument list and exit.

    • --usage
    Command-Line Format | --usage

    Display help text and exit; same as --help.

    • --verbose
    Command-Line Format | --verbose

    Provide extra information in the tool's output regarding its progress.

    • --version
    Command-Line Format | --version

    Display version information and exit.
Example

First we create an NDB table in the test database, using the CREATE TABLE statement shown here:

    USE test;
    CREATE TABLE btest (
        c0 BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
        c1 TEXT,
        c2 BLOB
    )   ENGINE=NDB;

Then we insert a few rows into this table, using a series of statements similar to this one:

    INSERT INTO btest VALUES (NULL, 'x', REPEAT('x', 1000));

When run with --check-orphans against this table, ndb_blob_tool generates the following output:

    $> ndb_blob_tool --check-orphans --verbose -d test btest
    connected
    processing 2 blobs
    processing blob #0 c1 NDB$BLOB_19_1
    NDB$BLOB_19_1: nextResult: res=1
    total parts: 0
    orphan parts: 0
    processing blob #1 c2 NDB$BLOB_19_2
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=1
    total parts: 10
    orphan parts: 0
    disconnected
    NDBT_ProgramExit: 0 - OK

The tool reports that there are no NDB BLOB column parts associated with column c1, even though c1 is a TEXT column. This is due to the fact that, in an NDB table, only the first 256 bytes of a BLOB or TEXT column value are stored inline, and only the excess, if any, is stored separately; thus, if there are no values using more than 256 bytes in a given column of one of these types, no BLOB column parts are created by NDB for this column. See Section 11.7, “Data Type Storage Requirements”, for more information.

COPYRIGHT

Copyright © 1997, 2022, Oracle and/or its affiliates.

This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.

This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA or see http://www.gnu.org/licenses/.

SEE ALSO
For more information, please refer to the MySQL Reference Manual, which may already be installed locally and which is also available online at http://dev.mysql.com/doc/.

AUTHOR
Oracle Corporation (http://dev.mysql.com/).